package com.dbxml.db.common.scripting;

/*
 * dbXML - Native XML Database
 * Copyright (C) 1999-2004  The dbXML Group, L.L.C.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * $Id: JavaScriptExtension.java,v 1.2 2004/02/12 00:17:56 bradford Exp $
 */

import java.util.Map;

import com.dbxml.labrador.types.Variant;

import org.mozilla.javascript.Context;
import org.mozilla.javascript.Scriptable;

/**
 * JavaScriptExtension is an experimental Extension for executing
 * JavaScript with the Mozilla Rhino interpreter.
 */

public final class JavaScriptExtension extends ScriptExtension {
   private static final String[] EmptyStrings = new String[0];

   public Variant execute(Map args) {
      Context ctx = Context.enter();
      ctx.setLanguageVersion(Context.VERSION_1_5);
      Scriptable scope = ctx.initStandardObjects(null);

      // Standard Variables
      scope.put("this", scope, Context.toObject(this, scope));
      scope.put("database", scope, Context.toObject(collection.getDatabase(), scope));
      scope.put("collection", scope, Context.toObject(collection, scope));

      // Arguments
      String[] names = (String[])args.keySet().toArray(EmptyStrings);
      for ( int i = 0; i < names.length; i++ ) {
         Object obj = args.get(names[i]);
         scope.put(names[i], scope, Context.toObject(obj, scope));
      }

      // Now run the actual script and populate the result
      try {
         ctx.evaluateString(scope, script, "<cmd>", 1, null);
      }
      catch ( Exception e ) {
      }

      Object res = scope.get("result", scope);
      if ( res != null )
         res = Context.toString(res);
      Context.exit();

		if ( res != null )
			return new Variant(res);
		else
			return null;
   }
}

